/********************************************
*                 glcdtest.c
*
* Simple test program for the glcd code
*
* Author: Michael Pearce <mike@kiwacan.co.nz>
*
* Started: 10  January 2007
*
* This program is provided under the GPL license
*   http://www.gnu.org/copyleft/gpl.html
*
********************************************/

#include <math.h>
#define PI 3.1415926535897931159979634685441851615905761718750 /* double */
#include "glcd.h"

int main( void )
{
  char str[20]; 
  unsigned int cnt;
  double  t;

  u08 x,y;

  CLKDIV=0x0040;
  PLLFBD=0x0028;
  OSCCON=0x0101;

 
  // reset lcd 
  lcd_reset_init();
  
 while(1) 
 {
  lcd_clear();


  show_icon( ( void * ) meter, 32, 32, 0, 10, LCD_PIXEL_ON ) ;
 
 select_font(( void * ) font_6x11, 6, 11 );

  draw_line( 44, 18, 44, 32, LCD_PIXEL_ON );
  draw_line( 34, 26, 132, 26, LCD_PIXEL_ON );
  

  draw_text( 37, 11, "glcd.c demo", LCD_PIXEL_INV);
    
  for ( x = 34; x < 132; x++ )
  {
      y = 26 + 6.0 * sin( 2 * PI * (x % 23) / 22 );
      draw_point( x, y, LCD_PIXEL_ON );
  }
  
  draw_rectangle( 92, 18, 132, 34, LCD_PIXEL_ON, LCD_PIXEL_INV );

  draw_text( 10, 64, "Press OPTION key", LCD_PIXEL_INV);  

  /* Wait until key is released */  
  while(PORTDbits.RD0==0);  


  /* Wait until key is pressed */  
  while(PORTDbits.RD0==1);
  
  

  /* Display Kiwacan Logo */
  lcd_clear();
  draw_text( 14, 64, "www.kiwacan.co.nz", LCD_PIXEL_INV);
  show_icon( ( void * ) kiwacan, 128, 32, 0, 0, LCD_PIXEL_ON ) ;

 

  /* Wait for key release */  
  while(PORTDbits.RD0==0);

  cnt=0;  

  /* Display a count while waiting for a key press */
  while(PORTDbits.RD0==1)
  {
   sprintf(str,"%u",cnt++);
   draw_text( 48, 50, str , LCD_PIXEL_ON );
   _delay_us(100);
  }

  
 } /* End while(1) */
 
 return 0; /* Should never get here! */
}


